﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Nixory - antispyware tool 
## Version: 1.1

##Released under GNU General Public License v2


import gtk, pygtk
pygtk.require('2.0')

def winshow(widget, destroyw, delete_event, languageconfig, nametheme, trwin):
    
    #Window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.connect("delete_event", delete_event)
    win.set_position(gtk.WIN_POS_CENTER)
    win.set_default_size(390, 228)
    win.set_resizable(True)
    win.set_title(languageconfig.get('EVENTWINDOW','window_title'))
    win.set_modal(True)
    win.set_transient_for(trwin)
        
    #Table
    evltable = gtk.Table(3, 5, False)
        
    #Add Pixbuf
    opterm = gtk.gdk.pixbuf_new_from_file("%s/opt_s.png" % nametheme)
    opfail = gtk.gdk.pixbuf_new_from_file("%s/opt_f.png" % nametheme)
	
    #ListStore
    evliststore = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)
    
    #Fill liststore
    for obj in open('etc/evlog.cfg','r').readlines():
        obj = obj.replace('\n','')
        obj = obj.split('\t')

        #Skip empty lines
        if len(obj) < 4:
            pass
        else:
            evliststore.append([gtk.gdk.pixbuf_new_from_file("%s/%s.png" % (nametheme, obj[0])), languageconfig.get('EVENTWINDOW', obj[1]).replace('%version',obj[4]) , obj[2], obj[3]])
        
        
            
    #TreeView
    evtreeview = gtk.TreeView(evliststore)
    evtreeview.set_rules_hint(True)
	
    #TreeViewColums
    colpix = gtk.TreeViewColumn('      ')
    colpix.set_resizable(True)
    colstr1 = gtk.TreeViewColumn(languageconfig.get('EVENTWINDOW','list_event'))
    colstr2 = gtk.TreeViewColumn(languageconfig.get('EVENTWINDOW','list_date') + ' '*14)
    colstr3 = gtk.TreeViewColumn(languageconfig.get('EVENTWINDOW','list_time') + ' '*5)
    
    #Append columns
    evtreeview.append_column(colpix)
    evtreeview.append_column(colstr1)
    evtreeview.append_column(colstr2)
    evtreeview.append_column(colstr3)        
    
    #Cellrenderers2
    cepix = gtk.CellRendererPixbuf()
    cestr1 = gtk.CellRendererText()
    cestr2 = gtk.CellRendererText()
    cestr3 = gtk.CellRendererText()
    
    #add cell renderers
    colpix.pack_start(cepix, True)
    colstr1.pack_start(cestr1, True)
    colstr2.pack_start(cestr2, True)
    colstr3.pack_start(cestr3, True)
    
    #set attributes
    colpix.set_attributes(cepix, pixbuf=0)
    colstr1.set_attributes(cestr1, text=1)
    colstr2.set_attributes(cestr2, text=2)
    colstr3.set_attributes(cestr3, text=3)
    cepix.set_property('stock-size', gtk.ICON_SIZE_SMALL_TOOLBAR)
    
    #Box Button Close
    evwclose = gtk.HBox(False, 0)
    evwcloseimg = gtk.Image()
    evwcloseimg.set_from_file('%s/deny.png' % nametheme)
    evwcloselab = gtk.Label('   ' + languageconfig.get('EVENTWINDOW','close_lab'))
    evwclose.pack_start(evwcloseimg, False, 1)
    evwclose.pack_start(evwcloselab, True, 1)
    evwclosebut = gtk.Button()
    evwclosebut.add(evwclose)
    evwclosebut.connect_object("clicked", gtk.Widget.destroy, win)
    
    #Label
    evllabel = gtk.Label(languageconfig.get('EVENTWINDOW','evt_label'))
    evswin = gtk.ScrolledWindow(None, None)
    evswin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
    evswin.add(evtreeview)	
    
    #Table append
    evltable.attach(evswin, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
    evltable.attach(evllabel, 0, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.FILL)
    evltable.attach(evwclosebut, 2, 3, 1, 2, 0|0, 0)
 
    win.add(evltable)
    win.show_all()