﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Nixory - antispyware tool 
## Version: 1.1

##Released under GNU General Public License v2


import pygtk, gtk
pygtk.require('2.0')
from os import path, mkdir, listdir, remove, getcwd
import subprocess
from pango import ELLIPSIZE_END
from shutil import move, rmtree
from winmodules import *
from platform import system as systemname
from getpass import getuser
import winwhite
from activeshield import actshield

def winshow(widget, destroyw, delete_event, languageconfig, globalconfig, nametheme, trwin, openactive = False, trayicon=None,):

    
    def save_changes(widget, trwin):
        #Save all changes into variables
        print 'Saving changes...'
        
        globalconfig.set('PREFERENCES','heur_ac', int(checkhe.get_active()))
        globalconfig.set('PREFERENCES','white_ac', int(checkwhite.get_active()))
        
        
        #Save profiles
        it = 0
        count1 = 1
        globalconfig.set('USER','profiles','')
        
        #Get names and paths
        while count1:
            try:
                value = liststore.get_value(liststore.get_iter(it),1)
            except ValueError:
                count1 = 0
            count = 1
            it2 = 0
            while count:
                     try:
                         value = liststore.get_value(liststore.get_iter('%s:%s' % (it, it2)),1)
                         globalconfig.set('USER','profiles',
                         globalconfig.get('USER','profiles') +
                         liststore.get_value(liststore.get_iter('%s:%s'
                         % (it, it2)),2) + '|' +
                         liststore.get_value(liststore.get_iter('%s:%s'
                         % (it, it2)),3) + '|' +
                         liststore.get_value(liststore.get_iter('%s:%s'
                         % (it, it2)),4) + '|' +
                         str(int(liststore.get_value(liststore.get_iter('%s:%s'
                         % (it, it2)),1))) + '||')
                      
                     except ValueError:
                         count = 0
                     it2 +=1
            it += 1
        
        #Save scan log settings
        globalconfig.set('PREFERENCES', 'wrlog', int(wrlog.get_active()))
        globalconfig.set('PREFERENCES', 'wrdet', int(wrdet.get_active()))
        globalconfig.set('PREFERENCES', 'wrback', int(wrbackup.get_active()))
        globalconfig.set('PREFERENCES', 'max_logs', int(adjustment.get_value()))
        
        #Save active shield settings
        globalconfig.set('PREFERENCES', 'run_at_startup', int(runcheck.get_active()))
        globalconfig.set('PREFERENCES', 'hide_icon', int(traycheck.get_active()))
        globalconfig.set('PREFERENCES', 'show_tooltip', int(tipcheck.get_active()))
        globalconfig.set('PREFERENCES', 'prog_check', int(progcheck.get_active()))

        #Rewrite configuration
        globalconfig.write(open('etc/gconfig.cfg','w'))
        
        #If hide_icon was enabled, hide if inactive
        if not actshield.isRunning and traycheck.get_active(): trayicon.set_visible(False)
        if not actshield.isRunning and not traycheck.get_active(): trayicon.set_visible(True)
        
        #If show_tooltip was enabled and icon is active show tooltip
        if tipcheck.get_active() and actshield.isRunning: trayicon.set_tooltip("Running:  %s Objects cleaned" % globalconfig.get("GENERAL", "shield_cleaned"))
        elif not tipcheck.get_active() and actshield.isRunning:  trayicon.set_tooltip("Nixory active shield running")
        
        #If run at startup was enabled or disabled edit registry (Windows only)
        #This will work only if nixory is run from a windows executable and are here commented out
        
        #COMMENT
        #if runcheck.get_active(): 
        #    execpath =  getcwd() + "\\" + 'nixory.exe'
        #    subprocess.Popen('REG ADD HKCU\\Software\\Microsoft\\Windows\\CurrentVersion\\Run /v Nixory /d "\\"%s\\" /nogui" /f' % execpath, shell=True, stdout=subprocess.PIPE,stdin=subprocess.PIPE, stderr=subprocess.PIPE)
        #else: subprocess.Popen('REG DELETE HKCU\\Software\\Microsoft\\Windows\\CurrentVersion\\Run /v Nixory /f', shell=True, stdout=subprocess.PIPE,stdin=subprocess.PIPE, stderr=subprocess.PIPE)
         
        gtk.Widget.destroy(trwin)
        
    
    def add_profile_firefox():
        #File chooser for firefox "cookie.sqlite"
        filebrowser = gtk.FileChooserDialog(languageconfig.get('PRWINDOW', 'FileChooser_title_firefox') , None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
        filebrowser.set_transient_for(win)
        filebrowser.set_modal(True)
        filebrowser.set_show_hidden(True)
        filter = gtk.FileFilter()
        filter.add_pattern("*")
        filebrowser.add_filter(filter)
        response = filebrowser.run()
        
        #Get user response
        if response == gtk.RESPONSE_ACCEPT:
            selected = unicode(filebrowser.get_filename())
            selectedfile = path.basename(selected)
            
            #Check validity
            if not path.exists(selected):
                show_error(languageconfig.get('PRWINDOW','error_not_found'), win, languageconfig.get('PRWINDOW','error_title'))
            elif selectedfile != "cookies.sqlite":
                show_error(languageconfig.get('PRWINDOW','error_invalid_firefox'), win, languageconfig.get('PRWINDOW','error_title'))
            elif profile_exists(path = selected, browser = "firefox" ):
                show_error(languageconfig.get('PRWINDOW','error_double'), win, languageconfig.get('PRWINDOW','error_title'))
            else:
                #Choose a profile name
                try:
                   #First choice, directory name
                   profilename = path.basename(path.dirname(selected))
                except:
                   try:
                       #Second choice, login user name
                       profilename = getuser()
                   except:
                        #If both failed, use default
                        profilename = "Default"
                        
                add_profile(True, "firefox", profilename, selected)
            
        if response == gtk.RESPONSE_REJECT:
            filebrowser.destroy()
        filebrowser.destroy()

    def add_profile_chrome():
        #File chooser for chrome "Cookies"
        filebrowser = gtk.FileChooserDialog(languageconfig.get('PRWINDOW', 'FileChooser_title_chrome') , None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
        filebrowser.set_transient_for(win)
        filebrowser.set_modal(True)
        filebrowser.set_show_hidden(True)
        filter = gtk.FileFilter()
        filter.add_pattern("*")
        filebrowser.add_filter(filter)
        response = filebrowser.run()
        
        #Get user response
        if response == gtk.RESPONSE_ACCEPT:
            selected = unicode(filebrowser.get_filename())
            selectedfile = path.basename(selected)
            
            #Check validity
            if not path.exists(selected):
                show_error(languageconfig.get('PRWINDOW','error_not_found'), win, languageconfig.get('PRWINDOW','error_title'))
            elif selectedfile != "Cookies":
                show_error(languageconfig.get('PRWINDOW','error_invalid_chrome'), win, languageconfig.get('PRWINDOW','error_title'))
            elif profile_exists(path = selected, browser = "firefox" ):
                show_error(languageconfig.get('PRWINDOW','error_double'), win, languageconfig.get('PRWINDOW','error_title'))
            else:
                #Choose a profile name
                try:
                   #First choice, directory name
                   profilename = path.basename(path.dirname(selected))
                except:
                   try:
                       #Second choice, login user name
                       profilename = getuser()
                   except:
                        #If both failed, use default
                        profilename = "Default"
                        
                add_profile(True, "chrome", profilename, selected)
            
        if response == gtk.RESPONSE_REJECT:
            filebrowser.destroy()
        filebrowser.destroy()

    def add_profile_ie():
        #File chooser for Internet Explorer "Cookies" directory
        filebrowser = gtk.FileChooserDialog(languageconfig.get('PRWINDOW', 'FileChooser_title_ie') , None, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
        filebrowser.set_transient_for(win)
        filebrowser.set_modal(True)
        filebrowser.set_show_hidden(True)
        filter = gtk.FileFilter()
        filter.add_pattern("*")
        filebrowser.add_filter(filter)
        response = filebrowser.run()
        
        #Get user response
        if response == gtk.RESPONSE_ACCEPT:
            selected = unicode(filebrowser.get_filename())
            selectedfile = path.basename(selected)
            
            #Check validity
            if not path.exists(selected):
                show_error(languageconfig.get('PRWINDOW','error_not_found'), win, languageconfig.get('PRWINDOW','error_title'))
            elif selectedfile != "Cookies":
                show_error(languageconfig.get('PRWINDOW','error_invalid_ie'), win, languageconfig.get('PRWINDOW','error_title'))
            elif profile_exists(path = selected, browser = "ie" ):
                show_error(languageconfig.get('PRWINDOW','error_double'), win, languageconfig.get('PRWINDOW','error_title'))
            else:
                #Choose a profile name
                try:
                   #First choice, user login name
                   profilename = getuser()
                except:
                    #Second choice, default
                    profilename = "Default"
                        
                add_profile(True, "ie", profilename, selected)
            
        if response == gtk.RESPONSE_REJECT:
            filebrowser.destroy()
        filebrowser.destroy()

    def profile_exists(path, browser):
        #check if profile already exists
        it = 0
        count = 1
        while count:
            try:
              if str(liststore.get_value(liststore.get_iter(it),4)) == browser:
                 break
              else:
                  it += 1
            except ValueError:
              count = 0
        else:
            #Browser was not found at all
            return False

        it2 = 0
        count = 1
        while count:
            try:
                if str(liststore.get_value(liststore.get_iter('%s:%s' % (it, it2)),3)) == path:
                    #Profile already in list
                    return True
                else:
                    it2 += 1
            except ValueError:
                count = 0
        else:
            #Profile not found
            return False
    
    
    def make_profilelist(widget):
            #Refresh profile list
            profilelist = globalconfig.get('USER','profiles')
            profilelist = profilelist.split('||')
            del profilelist[-1]

            #Browser order
            brorder = ("firefox", "ie", "chrome")
            for browser in brorder:
              for profile in profilelist:
                if profile.split('|')[2] == browser:
                  #Profile add
                  profile = profile.split('|')
                  add_profile(bool(int(profile[3])), profile[2], profile[0], profile[1])
                else:
                    pass


    def add_profile(toggled, browser, name, path):
            #Check if this browser is already in list
            it = 0
            count = 1
            global parentlist
            
            while count:
                try: 
                    if str(liststore.get_value(liststore.get_iter(it), 4)) == browser:
                        break
                    else:
                        it += 1
                except ValueError:
                        count = 0
            else:
                #If not, add it
                parentlist[str(it)] = liststore.append(None, [gtk.gdk.pixbuf_new_from_file("%s/%s.png" % (nametheme, browser)), None, languageconfig.get("PRWINDOW", browser), None, browser])

            #Add profile
            liststore.append(parentlist[str(it)], [gtk.gdk.pixbuf_new_from_file("%s/user.png" % nametheme), toggled, name, path,  browser])
            if toggled:
                if liststore.get_value(liststore.get_iter(it), 1):
                    pass
                else:
                    liststore.set_value(liststore.get_iter(it), 1, True)
                
    
    def cursor_changed(widget, type, *items):
        if type == 0:
            global cursorpos
            global treeview
            cursorpos = treeview.get_cursor()[0]

        
    def remove_item(widget, type, *items):
        if type == 0:
            global cursorpos
        
            #Remove from liststore selected row
            if cursorpos != None:
                if len(cursorpos) == 2:
                    liststore.remove(liststore.get_iter('%s:%s' % (cursorpos[0], cursorpos[1])))

                    #Remove browser is no profiles left
                    try:
                        if not liststore.iter_is_valid(liststore.get_iter('%s:0' % cursorpos[0])): liststore.remove(liststore.get_iter(cursorpos[0]))
                    except ValueError:
                        liststore.remove(liststore.get_iter(cursorpos[0]))
                    
                if len(cursorpos) == 1:
                    liststore.remove(liststore.get_iter(cursorpos[0]))

                cursorpos = None
           
        
    def wrlog_togg(*items):
        #Toggle check buttons
        wrlog.get_active()
        wrdet.set_sensitive(wrlog.get_active())
        logs.set_sensitive(wrlog.get_active())
        
    def clear_log(*items):
        #Clear log
        #Save backup if needed
        if wrbackup.get_active():
            open('etc/scan_log.txt.bk','w').write(open('etc/scan_log.txt','r').read())
        logfile = open('etc/scan_log.txt','w')
        logfile.flush()
        logfile.close()
        
        #Info Dialog
        adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text_log'))
        adv.set_title(languageconfig.get('PRWINDOW','infodiag_title_log'))
        adv.set_modal(True)
        adv.set_transient_for(win)
        adv.show()
        resp = adv.run()
        if resp == gtk.RESPONSE_CLOSE:
            adv.destroy()
        adv.destroy()
        
    def heur_warning(*items):
        if checkhe.get_active():
           #Display warning
           adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text_warning'))
           adv.set_title(languageconfig.get('PRWINDOW','infodiag_title_warning'))
           adv.set_modal(True)
           adv.set_transient_for(win)
           adv.show()
           resp = adv.run()
           if resp == gtk.RESPONSE_CLOSE:
              adv.destroy()
           adv.destroy()
        else:
            pass

    def toggle_white(*items):
        if checkwhite.get_active():
            whitebut.set_sensitive(True)
        else:
            whitebut.set_sensitive(False)


    def show_choosebrowser_win(widget):

        def select_browser(widget):
            #Every browser has a diffent dialog
            gtk.Widget.destroy(winbr)
            if firefoxrad.get_active():
                add_profile_firefox()
            elif ierad.get_active():
                add_profile_ie()
            elif chromerad.get_active():
                add_profile_chrome()
            else:
                pass


                
 
        #Choose browser dialogue

        #Start Window
        winbr = gtk.Window(gtk.WINDOW_TOPLEVEL)
        winbr.connect("delete_event", delete_event)
        winbr.set_position(gtk.WIN_POS_CENTER)
        winbr.set_default_size(245, 132)
        winbr.set_resizable(True)
        winbr.set_title(languageconfig.get('PRWINDOW','browser_title'))
        winbr.set_modal(True)
        winbr.set_transient_for(win)

        #Main Table
        dialogtable = gtk.Table(2, 2, False)
        
        #Check buttons
        firefoxrad = gtk.RadioButton(None, languageconfig.get('PRWINDOW','radio_firefox'))
        firefoxrad.set_active(True)
        chromerad = gtk.RadioButton(firefoxrad, languageconfig.get('PRWINDOW','radio_chrome'))
        ierad = gtk.RadioButton(firefoxrad, languageconfig.get('PRWINDOW','radio_ie'))
        
        #Check buttons VContainer
        vboxbr = gtk.VBox(False, 0)
        vboxbr.pack_start(firefoxrad, False, 1)
        vboxbr.pack_start(chromerad, False, 1)
        if systemname() == "Windows" or systemname() == "Microsoft": vboxbr.pack_start(ierad, False, 1)

        #Frame Container
        framebr = gtk.Frame(languageconfig.get('PRWINDOW','frame_browser'))
        framebr.set_label_align(0.5, 0.5)
        framebr.add(vboxbr)

        #Buttons
        #Box Button Apply
        applybox = gtk.HBox(False, 0)
        applyimage = gtk.Image()
        applyimage.set_from_file('%s/apply.png' % nametheme)
        applylab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','ok_lab'))
        applybox.pack_start(applyimage, False, 1)
        applybox.pack_start(applylab, True, 1)
        applybut = gtk.Button()
        applybut.add(applybox)
        applybut.connect('clicked', select_browser)
        #applybut.connect_object('clicked', gtk.Widget.destroy, winbr)
   
    
        #Box Button Cancel
        cancbox = gtk.HBox(False, 0)
        cancimage = gtk.Image()
        cancimage.set_from_file('%s/deny.png' % nametheme)
        canclab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','cancel_lab'))
        cancbox.pack_start(cancimage, False, 1)
        cancbox.pack_start(canclab, True, 1)
        cancbut = gtk.Button()
        cancbut.add(cancbox)
        cancbut.connect_object("clicked", gtk.Widget.destroy, winbr)
    
        #Button box
        ppbox = gtk.HBox(False, 0)
        ppbox.pack_start(cancbut, False, 1)
        ppbox.pack_start(applybut, False, 1)
        boxlab = gtk.Label(' ')

        #Attach elements
        dialogtable.attach(framebr ,0, 2, 0, 1, gtk.EXPAND|gtk.FILL, gtk.FILL|gtk.EXPAND, 1)
        dialogtable.attach(boxlab ,0, 1, 1, 2,  gtk.EXPAND|gtk.FILL, 0)
        dialogtable.attach(ppbox ,1, 2, 1, 2,  gtk.FILL|gtk.FILL, 0)
        
        winbr.add(dialogtable)
        winbr.show_all()


    def check_toggled(widget, iterl, *items):
        #Toggle check button
        liststore.set_value(liststore.get_iter(iterl),1, bool(int(liststore.get_value(liststore.get_iter(iterl),1)) - 1))
            
        #Toggle true/false all childs
        status = liststore.get_value(liststore.get_iter(iterl),1)
        iterl = str(iterl).split(':')
            
        if len(iterl) == 1:
                count = 1
                it = 0
                while count:
                      try:
                          liststore.set_value(liststore.get_iter('%s:%s' % (iterl[0], it)),1, status)
                      except ValueError:
                          count = 0
                      it += 1

        #If all childs are false, disable parent as well
        if len(iterl) == 2 and not status:
                count = 1
                it = 0
                while count:
                     try:
                         value = liststore.get_value(liststore.get_iter('%s:%s' % (iterl[0], it)),1)
                         if value:
                             break
                      
                     except ValueError:
                         count = 0
                     it +=1

                else:
                    liststore.set_value(liststore.get_iter(iterl[0]),1,False)

        #If child is enabled make sure parent is enabled too
        if len(iterl) == 2 and status:
               if not liststore.get_value(liststore.get_iter(iterl[0]),1):
                   liststore.set_value(liststore.get_iter(iterl[0]),1,True)
               else:
                   pass
        
    
    def runShield(*items):
        #Start shield
        actshield.start()
        
        #Update buttons
        stopbut.set_sensitive(True)
        runbut.set_sensitive(False)
        
        #Update text
        labstatus.set_markup('<big><b>Status: </b></big><big><span foreground="#2fa943"><b>Enabled</b></span></big>\n')
        
        #Update tray
        trayicon.set_from_file('%s/nixory_tray.png' % nametheme)
        if not trayicon.get_visible(): trayicon.set_visible(True)
        if int(globalconfig.get("PREFERENCES", "show_tooltip")): tooltip = "Running:  %s Objects cleaned" % globalconfig.get("GENERAL", "shield_cleaned")
        else: tooltip = "Nixory active shield running"
        trayicon.set_tooltip(tooltip)
        
    def stopShield(*items):
        #Stop shield
        actshield.stop()
        
        #Update buttons
        stopbut.set_sensitive(False)
        runbut.set_sensitive(True)
        
        #Update text
        labstatus.set_markup('<big><b>Status: </b></big><big><span foreground="#c80000"><b>Disabled</b></span></big>\n')
        
        #Update tray
        trayicon.set_from_file('%s/nixory_tray_inactive.png' % nametheme)
        if int(globalconfig.get('PREFERENCES','hide_icon')): trayicon.set_visible(False)
        trayicon.set_tooltip('Nixory active shield not running')
    
    
    #Preference Window
    
    #Start Window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.connect("delete_event", delete_event)
    win.set_position(gtk.WIN_POS_CENTER)
    win.set_default_size(590, 350)
    win.set_resizable(True)
    win.set_title(languageconfig.get('PRWINDOW','window_title'))
    win.set_modal(True)
    win.set_transient_for(trwin)
    
    #Main Table
    maintable = gtk.Table(2, 2, False)
    
    #Notebook
    notebook = gtk.Notebook()
    notebook.set_tab_pos(gtk.POS_TOP)
    
    ##Scan Section
    ####
    
    #Section table
    prtable = gtk.Table(2, 4, False)
    
    #Scrolled window
    scrollwin = gtk.ScrolledWindow(None, None)
    scrollwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
    
    #Tree liststore
    liststore = gtk.TreeStore(gtk.gdk.Pixbuf, bool, str, str, str)
    
    #TreeView
    global treeview
    treeview = gtk.TreeView(liststore)
    treeview.set_rules_hint(True)
    treeview.connect("cursor-changed",cursor_changed,0)
    
    
    #Make profile list
    global cursorpos
    global parentlist
    cursorpos = None
    parentlist = {}
    make_profilelist(None)

    #TreeViewColums
    columnpix = gtk.TreeViewColumn(None)
    columnstr = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_top') + '             ')
    columnstr2 = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_path'))
    columntype = gtk.TreeViewColumn(None)
    columntype.set_visible(False)
    
    #Append columns
    treeview.append_column(columnpix)
    treeview.append_column(columnstr)
    treeview.append_column(columnstr2)
    treeview.append_column(columntype)

    #Cellrenderers
    cellpix = gtk.CellRendererPixbuf()
    cellstr = gtk.CellRendererText()
    cellbool = gtk.CellRendererToggle()
    cellbool.set_property('activatable', True)
    cellbool.connect('toggled', check_toggled, iter)
    cellstr.set_property("ellipsize-set", True)
    cellstr.set_property("ellipsize", ELLIPSIZE_END)
    cellstr2 = gtk.CellRendererText()
    cellstr2.set_property("ellipsize-set", True)
    cellstr2.set_property("ellipsize", ELLIPSIZE_END)
    celltype = gtk.CellRendererText()

    #Add cell renderers
    columnpix.pack_start(cellpix, True)
    columnpix.pack_start(cellbool, True)
    columnstr.pack_start(cellstr, True)
    columnstr.set_resizable(True)
    columnstr2.pack_start(cellstr2, True)
    columntype.pack_start(celltype, True)

    #Set attributes
    columnpix.set_attributes(cellpix, pixbuf=0)
    columnpix.set_attributes(cellbool, active=1)
    columnstr.set_attributes(cellstr, text=2)
    columnstr2.set_attributes(cellstr2, text=3)
    cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    columntype.set_attributes(celltype, text=4)
    
    #Add TreeView to ScrolledWin
    scrollwin.add(treeview)

    #Label Profiles
    proflab = gtk.Label(' ' + languageconfig.get('PRWINDOW','label_profile'))
    
    #Remove profile button
    removebox = gtk.HBox(False, 0)
    removeimage = gtk.Image()
    removeimage.set_from_file('%s/clear.png' % nametheme)
    removelab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','removepr_lab'))
    removebox.pack_start(removeimage, False, 1)
    removebox.pack_start(removelab, True, 1)
    removebut = gtk.Button()
    removebut.add(removebox)
    removebut.connect('clicked',remove_item, 0)
    
    #Add profile button
    addbox = gtk.HBox(False, 0)
    addimage = gtk.Image()
    addimage.set_from_file('%s/add_new.png' % nametheme)
    addlab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','addpr_lab'))
    addbox.pack_start(addimage, False, 1)
    addbox.pack_start(addlab, True, 1)
    addbut = gtk.Button()
    addbut.add(addbox)
    addbut.connect('clicked',show_choosebrowser_win)
    
    #Button box
    pbox = gtk.HBox(False, 0)
    pbox.pack_start(removebut, False, 1)
    pbox.pack_start(addbut, False, 1)
    
    #HSeparator
    sep = gtk.HSeparator()
    
    #Frame(Infections filter) Container
    frame = gtk.Frame(languageconfig.get('PRWINDOW','frame_label'))
    frame.set_label_align(0.9, 0.5)
    
    
    #Check buttons
    checkhe = gtk.CheckButton(languageconfig.get('PRWINDOW','check_heur'))
    checkhe.set_active(int(globalconfig.get('PREFERENCES', 'heur_ac')))
    checkhe.connect('toggled', heur_warning)
    checkwhite = gtk.CheckButton(languageconfig.get('PRWINDOW','check_whitelist') + ' '*4)
    checkwhite.set_active(int(globalconfig.get('PREFERENCES', 'white_ac')))
    checkwhite.connect('toggled', toggle_white)

    #Configure whitelist button
    contbox = gtk.HBox(False, 0)
    whitebox = gtk.HBox(False, 0)
    whiteimage = gtk.Image()
    whiteimage.set_from_file('%s/preferences.png' % nametheme)
    whitelab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','white_lab'))
    nulllab = gtk.Label(' '*2)
    whitebox.pack_start(whiteimage, False, 0)
    whitebox.pack_start(whitelab, False, 0)
    whitebut = gtk.Button()
    whitebut.add(whitebox)
    whitebut.connect('clicked', winwhite.winshow, destroyw, delete_event, languageconfig, globalconfig, nametheme, win)
    contbox.pack_start(checkwhite, False, 0)
    contbox.pack_start(whitebut, False, 0)
    if not checkwhite.get_active(): whitebut.set_sensitive(False)
    
    #Check buttons VContainer
    vbox = gtk.VBox(False, 0)
    vbox.pack_start(checkhe, False, 1)
    vbox.pack_start(contbox, True, 1)
    
    #Add widgets -> frame
    frame.add(vbox)
                  
    #Attach elements
    prtable.attach(scrollwin, 0, 2, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL, 1)
    prtable.attach(proflab, 0, 1, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(pbox, 1, 2, 1, 2, gtk.FILL|gtk.FILL, 0)
    prtable.attach(sep, 0, 2, 2, 3, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(frame, 0, 2, 3, 4, gtk.EXPAND|gtk.FILL, 0)
    
    #Scan label box
    scanbox = gtk.HBox(False, 0)
    scanimage = gtk.Image()
    scanimage.set_from_file('%s/tab.png' % nametheme)
    scanlab = gtk.Label(' ' + languageconfig.get('PRWINDOW','scan_top'))
    scanimage.show()
    scanlab.show()
    scanbox.pack_start(scanimage, True, 1)
    scanbox.pack_start(scanlab, False, 1)
    
    
    ##Scan Log Section
    ####
    
    #Table
    scanlogtable = gtk.Table(3, 9, False)
    
    #Labels
    spaces = gtk.HSeparator()
    spaces2 = gtk.Label('\n')
    scanmax = gtk.Label(' ' + languageconfig.get('PRWINDOW','scanmax_log') + ' '*3)
    
    #CheckButtons
    wrlog = gtk.CheckButton(languageconfig.get('PRWINDOW','wrlog'))
    wrlog.set_active(int(globalconfig.get('PREFERENCES','wrlog')))
    wrlog.connect('toggled',wrlog_togg)
    wrdet = gtk.CheckButton(languageconfig.get('PRWINDOW','wrdet'))
    wrdet.set_active(int(globalconfig.get('PREFERENCES','wrdet')))
    wrbackup = gtk.CheckButton(languageconfig.get('PRWINDOW','wrback'))
    wrbackup.set_active(int(globalconfig.get('PREFERENCES','wrback')))
    
    #HScale and adjustment
    adjustment = gtk.Adjustment(float(globalconfig.get('PREFERENCES', 'max_logs')), 1, 50, 0, 0, 0)
    logs = gtk.HScale(adjustment)
    logs.set_digits(0)
    
    #Toggle check buttons
    wrlog_togg()
    
    #Separators
    hssep = gtk.HSeparator()
    
    #Box Button Clear Log
    clearlbox = gtk.HBox(False, 0)
    clearlimage = gtk.Image()
    clearlimage.set_from_file('%s/clear.png' % nametheme)
    clearllab = gtk.Label(' ' + languageconfig.get('PRWINDOW','clear_log'))
    clearlbox.pack_start(clearlimage, False, 1)
    clearlbox.pack_start(clearllab, True, 1)
    clearlbut = gtk.Button()
    clearlbut.add(clearlbox)
    clearlbut.connect('clicked', clear_log)
    
    #Button box
    pppbox = gtk.HBox(False, 0)
    pppbox.pack_start(clearlbut, False, 1)
    
    #Attach
    scanlogtable.attach(spaces ,0, 3, 0, 1, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrlog ,0, 3, 1, 2, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrdet ,0, 3, 2, 3, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrbackup ,0, 3, 3, 4, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(spaces2 ,0, 3, 4, 5, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(logs ,2, 3, 5, 6, gtk.EXPAND|gtk.FILL, 0)
    scanlogtable.attach(scanmax ,0, 2, 5, 6, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(hssep ,0, 3, 6, 7, gtk.EXPAND|gtk.FILL, 0)
    scanlogtable.attach(pppbox ,0, 3, 7, 8, gtk.EXPAND|gtk.FILL, 0)
    
    #Scan label box
    scanlogbox = gtk.HBox(False, 0)
    scanlogimage = gtk.Image()
    scanlogimage.set_from_file('%s/tab.png' % nametheme)
    scanloglab = gtk.Label(' ' + languageconfig.get('PRWINDOW','scanlog_top'))
    scanlogimage.show()
    scanloglab.show()
    scanlogbox.pack_start(scanlogimage, True, 1)
    scanlogbox.pack_start(scanloglab, False, 1)
    
    ##Active shield Section
    ####
    
    #Table
    shieldtable = gtk.Table(3, 9, False)
    
    #Labels
    spacelabe = gtk.Label(" ")
    labstatus = gtk.Label()
    if actshield.isRunning: labstatus.set_markup('<big><b>Status: </b></big><big><span foreground="#2fa943"><b>Enabled</b></span></big>\n')
    else: labstatus.set_markup('<big><b>Status: </b></big><big><span foreground="#c80000"><b>Disabled</b></span></big>\n')
    labclean = gtk.Label(languageconfig.get("PRWINDOW","detail").replace("NUM1", str(globalconfig.get("GENERAL","shield_scanned"))) + "\n" + languageconfig.get("PRWINDOW","detail2").replace("NUM2", str(globalconfig.get("GENERAL","shield_cleaned"))) + "\n" )
    
    #Frames
    frameopt = gtk.Frame(languageconfig.get('PRWINDOW','frame_opt'))
    frameopt.set_label_align(0.9, 0.5)
    
    #GTK alignment
    alstatus = gtk.Alignment(0, 0, 0, 0)
    alclean = gtk.Alignment(0, 0, 0, 0)
    alstatus.add(labstatus)
    alclean.add(labclean)
    
    #Image
    shieldimg = gtk.Image()
    shieldimg.set_from_file('%s/active_shield_big.png' % nametheme)
    
    #CheckButtons
    runcheck = gtk.CheckButton(languageconfig.get('PRWINDOW','runcheck'))
    runcheck.set_active(int(globalconfig.get('PREFERENCES','run_at_startup')))
    traycheck = gtk.CheckButton(languageconfig.get('PRWINDOW','traycheck'))
    traycheck.set_active(int(globalconfig.get('PREFERENCES','hide_icon')))
    tipcheck = gtk.CheckButton(languageconfig.get('PRWINDOW','tipcheck'))
    tipcheck.set_active(int(globalconfig.get('PREFERENCES','show_tooltip')))
    progcheck = gtk.CheckButton(languageconfig.get('PRWINDOW','progcheck'))
    progcheck.set_active(int(globalconfig.get('PREFERENCES','prog_check')))


    #Box Button Run
    runbox = gtk.HBox(False, 0)
    runimage = gtk.Image()
    runimage.set_from_file('%s/run.png' % nametheme)
    runlab = gtk.Label(' ' + languageconfig.get('PRWINDOW','run_shield'))
    runbox.pack_start(runimage, False, 1)
    runbox.pack_start(runlab, True, 1)
    runbut = gtk.Button()
    runbut.add(runbox)
    runbut.connect('clicked', runShield)
    
    #Box Button Stop
    stopbox = gtk.HBox(False, 0)
    stopimage = gtk.Image()
    stopimage.set_from_file('%s/stop.png' % nametheme)
    stoplab = gtk.Label(' ' + languageconfig.get('PRWINDOW','stop_shield'))
    stopbox.pack_start(stopimage, False, 1)
    stopbox.pack_start(stoplab, True, 1)
    stopbut = gtk.Button()
    stopbut.add(stopbox)
    stopbut.connect('clicked', stopShield)
    
    #Set sensitive
    if actshield.isRunning: runbut.set_sensitive(False)
    else: stopbut.set_sensitive(False)
    
    #Button box
    butsbox = gtk.HBox(False, 0)
    butsbox.pack_start(stopbut, False, 1)
    butsbox.pack_start(runbut, False, 1)
    
    #Check box
    optbox = gtk.VBox(False, 0)
    #This will work only with the windows executable
    #COMMENT
    #optbox.pack_start(runcheck, False, 1)
    optbox.pack_start(progcheck, False, 1)
    optbox.pack_start(traycheck, False, 1)
    optbox.pack_start(tipcheck, False, 1)
    
    #Details box
    detbox = gtk.VBox(False, 0)
    detbox.pack_start(alstatus, False, 1)
    detbox.pack_start(alclean, False, 1)
    detbox.pack_start(butsbox, False, 1)
    
    #Upper box
    upbox = gtk.HBox(False, 0)
    upbox.pack_start(shieldimg, False, 1)
    upbox.pack_start(detbox, False, 1)
    
    #Add widgets -> frame
    frameopt.add(optbox)
    
    #Attach
    shieldtable.attach(upbox ,0, 3, 0, 3, gtk.FILL|gtk.EXPAND, 0)
    shieldtable.attach(frameopt ,0, 3, 3, 4, gtk.FILL|gtk.FILL, gtk.FILL|gtk.EXPAND)
    shieldtable.attach(spacelabe ,0, 3, 4, 9, gtk.EXPAND|gtk.FILL, gtk.FILL|gtk.EXPAND)
    
    #Scan label box
    shieldtabbox = gtk.HBox(False, 0)
    shieldtabimage = gtk.Image()
    shieldtabimage.set_from_file('%s/tab.png' % nametheme)
    shieldtablab = gtk.Label(' ' + languageconfig.get('PRWINDOW','shieldtab_top'))
    shieldtabimage.show()
    shieldtablab.show()
    shieldtabbox.pack_start(shieldtabimage, True, 1)
    shieldtabbox.pack_start(shieldtablab, False, 1)
    
    ############
    
    #Append pages
    notebook.append_page(prtable, scanbox)
    notebook.append_page(shieldtable, shieldtabbox)
    notebook.append_page(scanlogtable, scanlogbox)
    
    #Buttons
    #Box Button Apply
    applybox = gtk.HBox(False, 0)
    applyimage = gtk.Image()
    applyimage.set_from_file('%s/apply.png' % nametheme)
    applylab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','apply_lab'))
    applybox.pack_start(applyimage, False, 1)
    applybox.pack_start(applylab, True, 1)
    applybut = gtk.Button()
    applybut.add(applybox)
    applybut.connect('clicked', save_changes, win)
   
    
    #Box Button Cancel
    cancbox = gtk.HBox(False, 0)
    cancimage = gtk.Image()
    cancimage.set_from_file('%s/deny.png' % nametheme)
    canclab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','cancel_lab'))
    cancbox.pack_start(cancimage, False, 1)
    cancbox.pack_start(canclab, True, 1)
    cancbut = gtk.Button()
    cancbut.add(cancbox)
    cancbut.connect_object("clicked", gtk.Widget.destroy, win)
    
    #Button box
    ppbox = gtk.HBox(False, 0)
    ppbox.pack_start(applybut, False, 1)
    ppbox.pack_start(cancbut, False, 1)
    
    #Attach
    maintable.attach(notebook ,0, 2, 0, 1, gtk.EXPAND|gtk.FILL, gtk.FILL|gtk.EXPAND, 1)
    maintable.attach(ppbox ,0, 2, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    
    #Show main window
    win.add(maintable)
    win.show_all()
    
    if openactive: notebook.set_current_page(1) #Open active shield if requested