﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Nixory - antispyware tool 
## Version: 1.1

##Released under GNU General Public License v2


import gtk, pygtk, gobject
pygtk.require('2.0')
import socket, select, time
from winmodules import *
import webbrowser

def winshow(widget, destroyw, delete_event, globalconfig, nametheme, trwin):
    
    def destroy_progress(*items):
        global timerexists, timer
        if timerexists:
            gobject.source_remove(timer)
            timerexists = False
        else:
            pass
    
    def socket_conn(*items):        
        #Starting connection
        global updsocket, connstate, data, timestart, cnnd
        statuslab.set_text("Connecting to server...")
        updsocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        updsocket.setblocking(0)
        try:
           updsocket.connect(('nixory.sourceforge.net',80))
        except socket.gaierror:
           #GAIE Error
           destroy_progress()
           
           #Show error message
           show_error('Could not connect to server.', win, "Error")
           gtk.Widget.destroy(win)
           
        except socket.error:
           connstate = 0
           data = ''
           cnnd = False
           timestart = time.clock()
           gobject.idle_add(select_eco)
           
    def select_eco(*items):
      global timerexists
      if timerexists:  
        #Data transfer
        global updsocket, connstate, timestart, cnnd, data, reciv
        readyr, readyw, readye = select.select([updsocket], [updsocket], [updsocket], 0)
        select.select([updsocket], [updsocket], [updsocket], 0)

        #First state: contacting server
        if connstate == 0:
           if updsocket in readyw:
               connstate = 1
               statuslab.set_text("Sending request...")
               updsocket.send('GET /definitions/lastver HTTP/1.1\r\nHost: nixory.sourceforge.net\r\n\r\n')
           else:
                timeend = time.clock()
                if (timeend - timestart) > 100:
                   updsocket.close()
                   destroy_progress()
                   show_error("Connection timed out.", win,'Error')
                   gtk.Widget.destroy(win)
                   
                   return False

        #Second state: downloading data
        if connstate == 1:
            if updsocket in readyr:
                if cnnd is False:
                   statuslab.set_text("Retriving data...")
                   cnnd = True
                reciv = updsocket.recv(3)
                data += reciv
                #If reached the end of file marker, stop process
                if reciv[-1] == '*':
                  data = data[:-1]
                  data = data.split('\n')[-2:]
                  connstate = 2
                  statuslab.set_text("Completed")
                  destroy_progress()
                  updsocket.close()
                  nvupdates()
                  return False

        #Third state: Connection closed 
        if connstate != 2:
            return True
        else:
           updsocket.close()
           return False
      else:
           updsocket.close()
           return False
       
    def progress_start(*items):
        #Start moving status bar
        global timerexists, timer
        timer = gobject.timeout_add(50, progress_pulse)
        timerexists = True
       
    def progress_pulse(*items):
        #Pulse status bar
        bar.pulse()
        return True
        
    def nvupdates(*items):
        global data
        
        idver = data[0]
        namever = data[1]
        
        
        #New program version available
        if int(globalconfig.get('PROGRAM', 'version')) < int(idver):
           webbrowser.open_new_tab('http://nixory.sourceforge.net')
           statuslab.set_text("New version available")
           
        else:
           statuslab.set_text("Your Nixory version is up-to-date")
    
    #Window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.connect("delete_event", delete_event)
    win.set_position(gtk.WIN_POS_CENTER)
    win.set_default_size(350, 10)
    win.set_resizable(True)
    win.set_title("Nixory update")
    win.set_modal(True)
    win.set_transient_for(trwin)
    
    #Content
    statuslab = gtk.Label("Please wait...")
    
    #Progress Bar
    bar = gtk.ProgressBar()
    bar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
    bar.pulse()
    bar.set_pulse_step(0.05)
    
    
    #Box Button report bug
    container = gtk.HBox(False, 0)
    container.pack_start(statuslab, False, 1)
    container.pack_end(bar, False, 1)
    
    
    #Show dialog
    win.add(container)
    win.show_all()
    win.set_focus(None)
    
    #Run update
    progress_start()
    socket_conn()
