﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Nixory - antispyware tool 
## Version: 1.1

##Released under GNU General Public License v2


import gtk, pygtk
from winmodules import *
pygtk.require('2.0')

def winshow(widget, destroyw, delete_event, languageconfig, globalconfig, nametheme, trwin):
    
    def show_input_dialog(widget, *items):
        #Input Dialog
        inputd = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK_CANCEL, None)
        inputd.set_title(languageconfig.get('WHITEWINDOW','infodiag_title'))
        inputd.set_modal(True)
        inputd.set_transient_for(win)
        inputd.format_secondary_markup(languageconfig.get('WHITEWINDOW','infodiag'))
        
        #Content
        entry = gtk.Entry()
        
        #Hbox
        hbox = gtk.HBox()
        hbox.pack_start(gtk.Label(languageconfig.get('WHITEWINDOW','host')), False, 5, 5)
        hbox.pack_end(entry)
        inputd.vbox.pack_end(hbox, True, True, 0)
        inputd.show_all()
        resp = inputd.run()
        if resp == gtk.RESPONSE_OK:
            add_list_item(entry.get_text())
            inputd.destroy()
        if resp == gtk.RESPONSE_CANCEL:
            inputd.destroy()
        inputd.destroy()
        
    def add_list_item(text):
        #Check validity
        global listchanged
        if not text:
            pass
        elif not '.' in text:
            show_error(languageconfig.get('WHITEWINDOW','error_invalid'), win, languageconfig.get('WHITEWINDOW','error_title'))
        else:
            liststore.append([gtk.gdk.pixbuf_new_from_file("%s/www.png" % nametheme), text])
            if not listchanged: listchanged = True
            
    def remove_item(widget, *items):
        #Remove highlited
        global cursortree
        global listchanged
        if cursortree != None:
           liststore.remove(liststore.get_iter(cursortree))
           cursortree = None
           if not listchanged: listchanged = True
        else:
            pass
            
    def cursor_changed(widget, *items):
        #Change cursor
        global cursortree
        global treeviewi
        
        cursortree = treeviewi.get_cursor()[0][0]

        
    def save_list(widget, *items):
       #Save changes
       global listchanged
       if listchanged:
        print "Saving whitelist..." #Debug information
        
        globalconfig.set("USER", "whitelist", "")
        it = liststore.get_iter_first()
        while it:
            globalconfig.set("USER","whitelist",globalconfig.get("USER","whitelist") + liststore.get_value(it, 1) + ';')
            it = liststore.iter_next(it)
        
        #Write    
        globalconfig.write(open('etc/gconfig.cfg','w'))
       else:
           #If no modifies were applied, skip this step
           pass
            
           
    #Global var
    global cursortree
    global listchanged
    cursortree = None
    listchanged = False
    
    
    #Window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.connect("delete_event", save_list)
    win.connect("delete_event", delete_event)
    win.set_position(gtk.WIN_POS_CENTER)
    win.set_default_size(390, 228)
    win.set_resizable(True)
    win.set_title(languageconfig.get('WHITEWINDOW','window_title'))
    win.set_modal(True)
    win.set_transient_for(trwin)
        
    #Table
    whitetable = gtk.Table(3, 5, False)
        
    #Add Pixbuf
    pic = gtk.gdk.pixbuf_new_from_file("%s/opt_s.png" % nametheme)
	
    #ListStore
    liststore = gtk.ListStore(gtk.gdk.Pixbuf, str)
    
    #Fill liststore
    urllist = globalconfig.get("USER","whitelist").split(';')
    del urllist[-1]
    
    for url in urllist:
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/www.png" % nametheme), url])
        
            
    #TreeView
    global treeviewi
    treeviewi = gtk.TreeView(liststore)
    treeviewi.set_rules_hint(True)
    treeviewi.connect("cursor-changed",cursor_changed)
	
    #TreeViewColums
    colpix = gtk.TreeViewColumn('      ')
    colpix.set_resizable(True)
    colstr1 = gtk.TreeViewColumn(languageconfig.get('WHITEWINDOW','list_url'))
    
    #Append columns
    treeviewi.append_column(colpix)
    treeviewi.append_column(colstr1)    
    
    #Cellrenderers2
    cepix = gtk.CellRendererPixbuf()
    cestr1 = gtk.CellRendererText()
    
    #add cell renderers
    colpix.pack_start(cepix, True)
    colstr1.pack_start(cestr1, True)
    
    #set attributes
    colpix.set_attributes(cepix, pixbuf=0)
    colstr1.set_attributes(cestr1, text=1)
    cepix.set_property('stock-size', gtk.ICON_SIZE_SMALL_TOOLBAR)
    
    #Box Button Close
    closebox = gtk.HBox(False, 0)
    closeimg = gtk.Image()
    closeimg.set_from_file('%s/deny.png' % nametheme)
    closelab = gtk.Label('   ' + languageconfig.get('WHITEWINDOW','close_lab'))
    closebox.pack_start(closeimg, False, 1)
    closebox.pack_start(closelab, True, 1)
    closebut = gtk.Button()
    closebut.add(closebox)
    closebut.connect("clicked", save_list)
    closebut.connect_object("clicked", gtk.Widget.destroy, win)

    #Box Button add
    addbox = gtk.HBox(False, 0)
    addimg = gtk.Image()
    addimg.set_from_file('%s/add_new.png' % nametheme)
    addlab = gtk.Label('   ' + languageconfig.get('WHITEWINDOW','add_lab'))
    addbox.pack_start(addimg, False, 1)
    addbox.pack_start(addlab, True, 1)
    addbut = gtk.Button()
    addbut.add(addbox)
    addbut.connect("clicked", show_input_dialog)

    #Box Button remove
    removebox = gtk.HBox(False, 0)
    removeimg = gtk.Image()
    removeimg.set_from_file('%s/clear.png' % nametheme)
    removelab = gtk.Label('   ' + languageconfig.get('WHITEWINDOW','remove_lab'))
    removebox.pack_start(removeimg, False, 1)
    removebox.pack_start(removelab, True, 1)
    removebut = gtk.Button()
    removebut.add(removebox)
    removebut.connect("clicked", remove_item)

    #Button box
    pbox = gtk.HBox(False, 0)
    pbox.pack_start(closebut, False, 1)
    pbox.pack_start(removebut, False, 1)
    pbox.pack_start(addbut, False, 1)
    
    #Label
    label = gtk.Label(languageconfig.get('WHITEWINDOW','desc_label'))
    swin = gtk.ScrolledWindow(None, None)
    swin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
    swin.add(treeviewi)	
    
    #Table append
    whitetable.attach(swin, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
    whitetable.attach(label, 0, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.FILL)
    whitetable.attach(pbox, 2, 3, 1, 2, 0|0, 0)
 
    win.add(whitetable)
    win.show_all()